; ===============================================================
; Move Effect ID Constants
; ===============================================================

#define qNoEffect		0	; no effect (dragon claw, drill peck, hydro pump, hyper voice, mega kick, megahorn)

; ---------------------------------------------------------------
; stat changers (raise)
; ---------------------------------------------------------------

#define qAtkRaise		1	; raises attacking pkmn attack by 1 stage (metal claw, meteor mash)
#define qDefRaise		2	; raises attacking pkmn defense by 1 stage (steel wing)
#define qEvaRaise		3	; raises attacking pkmn evasion by 1 stage (double team, minimize)
#define qAtkRaise2		4	; raises attacking pkmn attack by 2 stages (swords dance)
#define qDefRaise2		5	; raises attacking pkmn defense by 2 stages (acid armor, barrier)
#define qSpDefRaise2		6	; raises attacking pkmn sp defense by 2 stages (amnesia)
#define qSpdRaise2		7	; raises attacking pkmn speed by 2 stages (agility)
#define qAtkDefRaise		8	; raises attacking pkmn attack and defense (bulk up)
#define qSpAtkDefRaise	9	; raises attacking pkmn spec attack and defense (calm mind)
#define qDefSpDefRaise	10	; raises attacking pkmn defense and sp defense (cosmic power)
#define qAtkSpdRaise		11	; raises attacking pkmn attack and speed (dragon dance)
#define qAllStatsRaise	12	; raises all attacking pkmn stats (ancient power, silver wind)

; ---------------------------------------------------------------
; stat changers (lower)
; ---------------------------------------------------------------

#define qDefLower		13	; lowers target pkmn defense by 1 stage (crush claw, steel wing)
#define qSpDefLower		14	; lowers target pkmn sp defense by 1 stage (crunch, luster purge, psychic, shadow ball)
#define qSpAtkLower		15	; lowers target pkmn sp attack by 1 stage (mist ball)
#define qSpdLower		16	; lowers target pkmn speed by 1 stage (icy wind, rock tomb)
#define qAccLower		17	; lowers target pkmn accuracy by 1 stage (flash, mud-slap, sand-attack, smokescreen)
#define qEvaLower		18	; lowers target pkmn evasion by 1 stage (sweet scent)
#define qAtkLower2		19	; lowers target pkmn attack by 2 stages (charm)
#define qDefLower2		20	; lowers target pkmn defense by 2 stages (iron tail, screech)
#define qSpDefLower2		21	; lowers target pkmn sp defense by 2 stages (fake tears)
#define qSpdLower2		22	; lowers target pkmn speed by 2 stages (scary face)
#define qUserSpAtkLower2	23	; lowers attacking pkmn sp attack by 2 stages (overheat)
#define qUserAtkDefLower	24	; lowers attacking pkmn attack and defense by 1 stage (superpower)

; ---------------------------------------------------------------
; status inducers
; ---------------------------------------------------------------

#define qBurn			25	; attack burns the target (fire blast, fire punch, flamethrower, heat wave, will-o-wisp)
#define qFreeze		26	; attack freezes the target (ice beam, ice punch)
#define qParalyze		27	; attack paralyzes the target (body slam, dragon breath, secret power, spark, stun spore, TW, TB, TP, ZC)
#define qPoison		28	; attack poisons the target (sludge bomb)
#define qBadPoison		29	; attack badly poisons the target (toxic)
#define qSleep		30	; attack causes target to sleep (grasswhistle, hypnosis, lovely kiss, sing, sleep powder, spore)
#define qTri			31	; may paralyze/burn/freeze target (20%) (tri attack)
#define qYawn			32	; causes target to sleep at end of 2nd turn (yawn)

; ---------------------------------------------------------------
; volatile status inducers
; ---------------------------------------------------------------

#define qDisable		33	; target pkmn move disabled (disable) - (2 pkmn, dewgong2, alakazam3, remove?)
#define qLeechSeed		34	; plants seeds on target, leeches 1/8 HP, no effect on grass pkmn (leech seed)
#define qEncore		35	; puts target in encore, 4-8 turns or until PP ends (encore) (1 pkmn, dewgong2, remove?)
#define qInfatuate		36	; attack induces infatuation (attract)
#define qConfuse		37	; attack induces confusion (confuse ray, dizzy punch, dynamic punch, sweet kiss, signal beam, water pulse)
#define qFollowMe		38	; user becomes center of attention (follow me)
#define qPrevEscape		39	; attack that prevents target from switching (block, mean look)
#define qPerishSong		40	; perish song causes all pkmn to faint in 3 turns, hits thru protect/detect (perish song)
#define qProtect		41	; protects user for 1 turn (detect, protect)
#define qSwagger		42	; confuses target but raises attack by 2 stages (swagger)
#define qTorment		43	; target can't use same move twice in row (torment) - (1 pkmn, mime3, remove?)
#define qTrap			44	; traps target for 2-5 turns, inflicts 1/16 HP (sand tomb, wrap)

; ---------------------------------------------------------------
; field effects
; ---------------------------------------------------------------

#define qHail			45	; causes the weather to hail for 5 turns (hail)
#define qLightScreen		46	; light screen protects team, spec damage x1/2 for 5 turns, ignored in critical hit (light screen)
#define qRainDance		47	; causes the weather to rain for 5 turns (rain dance)
#define qReflect		48	; reflect protects team, phys damage x1/2 for 5 turns, ignored in critical hit (reflect)
#define qSafeguard		49	; protects team from status conditions for 5 turns (safeguard)
#define qSandstorm		50	; turns the weather into a sandstorm for 5 turns (sandstorm)
#define qSpikes		51	; fills field with spikes, 12.5% dmg w/ 1 layer, 16.67% w/ 2, 25% w/ 3 on switch (spikes) - (2 pkmn)
#define qSunnyDay		52	; turns weather to sunny (sunny day)

; ---------------------------------------------------------------
; stall moves
; ---------------------------------------------------------------

#define qBounce		53	; jump up on first turn, may paralyze (30%), vulnerable to sky uppercut/thunder (bounce)
#define qDig			54	; user digs underground 1 turn, vulnerable to earthquake/fissure (dig)
#define qDive			55	; user dives underwater 1 turn, vulnerable to surf (dive)
#define qFly			56	; user flies up, vulnerable to sky uppercut/thunder (fly)

; ---------------------------------------------------------------
; misc effects
; ---------------------------------------------------------------

#define qNeverMiss		57	; attack never misses (aerial ace, faint attack, magical leaf, swift)
#define qHighCrit		58	; attack with high critical hit ratio (+2 stages) (air cutter, cross chop, leaf blade, slash)
#define qFlinch		59	; attack causes target to flinch (astonish, bite, headbutt, extrasensory, rock slide)
#define qHitTwice		60	; attack hits twice in a row (boomerang, double kick)
#define qRecoil		61	; attacking pkmn is hit with 1/3 recoil (double edge)
#define qPriority		62	; user attacks first (extremespeed, mach punch, quick attack)
#define qOHKO			63	; attack deals dmg = max HP (fissure, horn drill, sheer cold)
#define qReverse		64	; attack deals more damage w/ less HP (flail, reversal)
#define qFuture		65	; attack hits target in future, end of 3 turns, typeless (future sight) - (2 pkmn, xatu1, whiscash2, remove?)
#define qDrain		66	; attack drains 1/2 target's HP (giga drain)
#define qBlazeKick		67	; high crit hit ratio, may burn target (10%) (blaze kick)
#define qBlizzard		68	; may freeze (10%), hits thru protect/detect in hail (30%) (blizzard)
#define qEarthquake		69	; hits underground targets w/ 2x dmg (earthquake)
#define qFakeOut		70	; priority, flinches target, only used on 1st turn out (fake out)
#define qFocusPunch		71	; user flinches if hit (not w/ pain split) (focus punch)
#define qJumpKick		72	; attack hurts user min(1/2 damage, 1/2 target max HP) if it misses / protect / detect / ghost (high jump kick)
#define qCharge		73	; attack must charge afterwards, no attack/switch (hyper beam) - (1 pkmn, aerodactyl2, remove?)
#define qHeal			74	; heals 1/2 of user's HP (milk drink, recover, softboiled)
#define qWeatherHeal		75	; heals 2/3 HP in sun, 1/4 HP in other weather, 1/2 else (moonlight, synthesis)
#define qWish			76	; heals 1/2 HP at end of 2nd turn (wish)
#define qCure			77	; cures user of status effects (refresh)
#define qCureAll		78	; cures user and all party pkmn of status effects (aromatherapy) - (1 pkmn, vileplume1, remove?)
#define qLevelDmg		79	; damage is equal to user's level (100) (night shade, seismic toss)
#define qDuration		80	; lasts 2-3 turns, user is confused at end (petal dance, thrash)
#define qSkyAttack		81	; charges for 1 turn, 30% flinch (sky attack) - (1 pkmn, fearow4, remove?)
#define qSkyUppercut		82	; hits pkmn in fly and bounce (sky uppercut)
#define qSmellingSalt	83	; cures target and deals 2x damage if target paralyzed (smelling salt) - (1 pkmn, granbull1, remove?)
#define qSolarbeam		84	; charges on turn 1, skips charging if sunny, x1/2 power in hail/rain/sandstorm (solarbeam)
#define qSurf			85	; hits underwater pkmn w/ 2x dmg (surf)
#define qThunder		86	; may paralyze (30%), 1/2 accurate in sun, (thunder)

; ---------------------------------------------------------------
; move specific effects
; ---------------------------------------------------------------

#define qBatonPass		87	; swap to pkmn in party, retain stat changes (baton pass)
#define qBellyDrum		88	; maximizes attack, cuts HP in half (belly drum) - (1 pkmn, snorlax5, remove?)
#define qBrickBreak		89	; shatter reflect / light screen, even if miss/not affect (brick break)
#define qCounter		90	; counters physical attack w/ 2x damage (counter)
#define qCurse		91	; curse if ghost type, raise atk/def and lower spd if not (curse) - (1 ghost pkmn, dusclops4, remove?)
#define qDefCurl		92	; raises defense 1 stage, increase rollout damage (defense curl)
#define qDestinyBond		93	; target faints if attacking pkmn faints (destiny bond)
#define qDreamEater		94	; eats target's dream if asleep (dream eater)
#define qEndure		95	; user endures next hit w/ 1 HP, survives OHKOs (endure)
#define qExplosion		96	; user destroys itself, damage calc w/ 1/2 target's defense (explosion)
#define qFacade		97	; deals extra damage w/ burn, paralysis, and poison (facade)
#define qFrustration		98	; deals more damage with less happiness (frustration)
#define qGrudge		99	; target loses all move PP if user faints (grudge) - (1 pkmn, ninetales2, remove?)
#define qIngrain		100	; ingrains user, gain 1/16 max HP end of every turn, prev switching (ingrain)
#define qKnockOff		101	; knocks off target pkmn's item (knock off) - (1 pkmn, armaldo2, remove?)
#define qMemento		102	; user faints, target attack and sp attack fall 2 stages (memento) - (1 pkmn, weezing2, remove?)
#define qMetronome		103	; attacks with random move (metronome) - (1 pkmn, clefable1, remove?)
#define qMirrorCoat		104	; reflects special move damage 2x (mirror coat)
#define qNightmare		105	; reduces target's HP by 1/4 at end of turn, if asleep (nightmare) - (1 pkmn, hypno2, remove?)
#define qPainSplit		106	; splits HP of user and target equally (pain split) - (2 pkmn, misdreavus1, dusclops1, remove?)
#define qPsychUp		107	; copies stat changes of target (psych up)
#define qPursuit		108	; deals 2x damage if target switches out (pursuit) - (2 pkmn, fearow2, altaria2, remove?)
#define qRest			109	; user falls asleep for 2 turns, regains full HP and status (rest)
#define qRevenge		110	; if user takes damage, user deals 2x damage (revenge) - (1 pkmn, machamp5, remove?)
#define qSwitch		111	; causes target pkmn to switch out (roar)
#define qRollout		112	; attack 2-5 turns w/ inc damage, 2x damage w/ defense curl (rollout) - (1 pkmn, shuckle1, remove?)
#define qSkillSwap		113	; swaps skill with target (skill swap) - (2 pkmn, alakazam3, gengar3, remove?)
#define qSleepTalk		114	; attacks randomly during sleep (sleep talk)
#define qSubstitute		115	; uses 1/4 HP to produce substitute (substitute)
#define qTrick		116	; swaps items with target (trick) - (2 pkmn, mime3, alakazam3, remove?)

#define qRecoil2		117	; take 1/2 damage as recoil (struggle)