; ===============================================================
; Test
; Unit Tests for GenPoke
; ===============================================================

#ifdef TEST

#ifdef TEST_ROAR_GHOST
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fCharizard1
	#define TEST_PKMN2	fVaporeon1
	#define TEST_PKMN3	fDusclops1
#endif

#ifdef TEST_ROAR
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fWailord1
	#define TEST_PKMN2	fManectric1
	#define TEST_PKMN3	fBlaziken1
#endif

#ifdef TEST_TRICK
	#define TEST_TIER	fPKMN3
	#define TEST_PKMN1	fAlakazam3
	#define TEST_PKMN2	fMrmime3
	#define TEST_PKMN3	fJynx3
#endif

#ifdef TEST_BELLYDRUM
	#define TEST_TIER	fPKMN5
	#define TEST_PKMN1	fSnorlax5
	#define TEST_PKMN2	fSnorlax5
	#define TEST_PKMN3	fSnorlax5
#endif

#ifdef TEST_PAINSPLIT
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fMisdreavus1
	#define TEST_PKMN2	fDusclops1
	#define TEST_PKMN3	fTauros1
#endif

#ifdef TEST_SKILLSWAP
	#define TEST_TIER	fPKMN3
	#define TEST_PKMN1	fAlakazam3
	#define TEST_PKMN2	fGengar3
	#define TEST_PKMN3	fKangaskhan3
#endif

#ifdef TEST_AROMATHERAPY
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fVileplume1
	#define TEST_PKMN2	fJolteon1
	#define TEST_PKMN3	fVenusaur1
#endif

#ifdef TEST_SMELLINGSALT
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fGranbull1
	#define TEST_PKMN2	fJolteon1
	#define TEST_PKMN3	fVenusaur1
#endif

#ifdef TEST_SPIKES
	#define TEST_TIER	fPKMN2
	#define TEST_PKMN1	fSkarmory2
	#define TEST_PKMN2	fLapras2
	#define TEST_PKMN3	fClaydol2
#endif

#ifdef TEST_JUMPKICK
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fMedicham1
	#define TEST_PKMN2 	fDusclops1
	#define TEST_PKMN3	fArmaldo1
#endif

#ifdef TEST_METRONOME
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fClefable1
	#define TEST_PKMN2	fGengar1
	#define TEST_PKMN3	fMrmime1
#endif

#ifdef TEST_ROLLOUT
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fShuckle1
	#define TEST_PKMN2	fMisdreavus1
	#define TEST_PKMN3	fArmaldo1
#endif

#ifdef TEST_GRUDGE
	#define TEST_TIER	fPKMN2
	#define TEST_PKMN1	fNinetales2
	#define TEST_PKMN2	fDugtrio2
	#define TEST_PKMN3	fRhydon2
#endif

#ifdef TEST_MEMENTO
	#define TEST_TIER	fPKMN2
	#define TEST_PKMN1	fWeezing2
	#define TEST_PKMN2	fMetagross2
	#define TEST_PKMN3	fDusclops2
#endif

#ifdef TEST_NIGHTMARE
	#define TEST_TIER	fPKMN2
	#define TEST_PKMN1	fHypno2
	#define TEST_PKMN2	fSlowbro2
	#define TEST_PKMN3	fGardevoir2
#endif

#ifdef TEST_SKYATTACK
	#define TEST_TIER	fPKMN4
	#define TEST_PKMN1	fFearow4
	#define TEST_PKMN2	fSkarmory4
	#define TEST_PKMN3	fAltaria4
#endif

#ifdef TEST_TORMENT
	#define TEST_TIER	fPKMN3
	#define TEST_PKMN1	fMrmime3
	#define TEST_PKMN2	fWhiscash3
	#define TEST_PKMN3	fSlaking3
#endif

#ifdef TEST_DURATION
	#define TEST_TIER	fPKMN1
	#define TEST_PKMN1	fTauros1
	#define TEST_PKMN2	fVileplume1
	#define TEST_PKMN3	fJolteon1
#endif

#ifdef TEST_PURSUIT
	#define TEST_TIER	fPKMN2
	#define TEST_PKMN1	fFearow2
	#define TEST_PKMN2	fAltaria2
	#define TEST_PKMN3	fMedicham2
#endif

#ifdef TEST_SUBSTITUTE
	#define TEST_TIER	fPKMN2
	#define TEST_PKMN1	fGolem2
	#define TEST_PKMN2	fMeganium2
	#define TEST_PKMN3	fBlissey2
#endif

#endif

; ---------------------------------------------------------------
; GenPoke:
; Generates a random pokemon
; Input: HL = location of generated poke
;	  (RoundNum) = Round #
; Output: HL = HL + 3
; ---------------------------------------------------------------

GenPoke:
	ld DE, RoundNum		; gen tier (1-5)
	ld A, (DE)
	cp 5
	jr c, GenPokeNot5
	ld B, 5
	call iRandom			; if round 5 or greater, then 1 <= A <= 5
	inc A
GenPokeNot5:
	ld (HL), A
	dec A
	inc HL				; gen #
	push HL
	ld HL, GenPokeDb
	ld D, 0
	ld E, A
	add HL, DE
	ld B, (HL)
	call iRandom
	
	#ifdef TEST
	cp 33
	jr nc, SelTeamR3
	ld A, (TEST_PKMN1 - TEST_TIER) / 7
	jr SelTeamRCont
SelTeamR3:
	cp 66
	jr nc, SelTeamR6
	ld A, (TEST_PKMN2 - TEST_TIER) / 7
	jr SelTeamRCont
SelTeamR6:
	ld A, (TEST_PKMN3 - TEST_TIER) / 7
SelTeamRCont:
	#endif
	
	pop HL
	ld (HL), A
	inc HL				; generate pid
	ld B, $FF
	call iRandom
	ld (HL), A
	inc HL
	ret
	
GenPokeDb:
.db (fPKMN1End - fPKMN1) / 7
.db (fPKMN2End - fPKMN2) / 7
.db (fPKMN3End - fPKMN3) / 7
.db (fPKMN4End - fPKMN4) / 7
.db (fPKMN5End - fPKMN5) / 7

Overworld_End:			; must be at end of overworld code
.echo "Overworld: "			; prints out amount of exe in bytes
.echo Overworld_End - Init
.echo " bytes. "
.echo "("
.echo 100 * (Overworld_End - Init) / (CodeSize) ; (8811)
.echo "%)\n"

.echo "Buffer: "
.echo CodeSize - (Overworld_End - Init)
.echo " bytes.\n"
.fill CodeSize - (Overworld_End - Init), $00			; buffer to prevent Relocate from corrupting data
