; ===============================================================
; Macros
; ===============================================================

; ---------------------------------------------------------------
; Misc
; ---------------------------------------------------------------

#define stop				di \ jr $ \ ei ; di \ jp $ \ ei
#define nops				nop \ nop \ nop \ nop

#define rVPutS(col, row, txt)	#if row != XX && col != XX \ ld HL, row * 256 + col \ ld (PenCol), HL
#defcont				\ #else 
#defcont				    \ #if col != XX \ ld A, col \ ld (PenCol), A \ #endif
#defcont				    \ #if row != XX \ ld A, row \ ld (PenRow), A \ #endif
#defcont				\ #endif
#defcont				\ ld HL, txt \ b_call(_VPutS)

#define rTextCoord(col, row)	#if col != XX && row != XX \ ld DE, row * 256 + col \ ld (PenCol), DE
#defcont				\ #else
#defcont					\ #if col != XX \ ld A, col \ ld (PenCol), A \ #endif
#defcont					\ #if row != XX \ ld A, row \ ld (PenRow), A \ #endif
#defcont				\ #endif

#define rReloc(lbl)			lbl - Battle + Program
#define RCall(clbl)			call RCall \ .db clbl
#define rTextbox(txt)		call RTextbox \ .dw txt
#define rTextboxRet(txt)		call RTextboxRet \ .dw txt
#define b_call(xxxx)			rst 28h \ .dw xxxx

#define lbl(aiLbl)			(aiLbl - aiFree) / 3 + 1

; ---------------------------------------------------------------
; Graphics
; ---------------------------------------------------------------

#define rGSLargeSprite(x, y, pt)	ld A, x \ ld L, y \ ld IX, pt \ RCall( cgsLargeSprite )

#define rGSPutSprite(x, y, pt)	ld A, x \ ld L, y \ ld IX, pt \ RCall( cgsPutSprite )

#define rArcPKMN(x, y, pkmn)	ld HL, x * 256 + y \ ld A, pkmn \ RCall( cArcPKMN )
#define rArcPKMN(x, y)		ld HL, x * 256 + y \ RCall( cArcPKMN )

#define rArcFront(x, y, pkmn)	ld HL, x * 256 + y \ ld A, pkmn \ RCall( cArcPKMN )
#define rArcFront(x, y)		ld HL, x * 256 + y \ RCall( cArcPKMN )

#define rArcBack(x, y, pkmn)	ld HL, x * 256 + y \ ld A, pkmn \ RCall( cArcBack )
#define rArcBack(x, y)		ld HL, x * 256 + y \ RCall( cArcBack )

#define rHorizLine(x, y, len)	ld HL, x * 256 + y \ ld B, len \ call HorizLine
#define rHorizLineD(x, y, len)	ld HL, x * 256 + y \ ld B, len \ call HorizLineDark
#define rHorizLineB(x, y, len)	ld HL, x * 256 + y \ ld B, len \ call HorizLineBlack

#define rVertLine(x, y, len)	ld HL, x * 256 + y \ ld B, len \ call VertLine
#define rVertLineD(x, y, len)	ld HL, x * 256 + y \ ld B, len \ call VertLineDark
#define rVertLineB(x, y, len)	ld HL, x * 256 + y \ ld B, len \ call VertLineBlack

#define rDrawBox(x, y, wid, ht)	ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cDrawBox )
#define rDrawBoxOut(x, y, wid, ht)	ld HL, x * 256 + y \ ld BC, wid * 256 + ht - 1 \ RCall( cDrawBoxOut )
#define rDrawBoxOutD(x, y, wid, ht)ld HL, x * 256 + y \ ld BC, wid * 256 + ht - 1 \ RCall( cDrawBoxOut3 )

#define rLdPoint(x, y)		ld HL, PlotSScreen + (x / 8) + (y * 12)
#define rLdPointG(x, y)		ld HL, SaveSScreen + (x / 8) + (y * 12)

#define rCopyBuffSect(x, y, wid, ht)	ld A, x \ ld L, y \ ld BC, 256 * wid + ht \ RCall( cCopyBuffSect )
#define rCopyBuffSect2(x, y, wid, ht)	ld A, x \ ld L, y \ ld BC, 256 * wid + ht \ RCall( cCopyBuffSect2 )

#define rFillBuffSect(f, x, y, w, ht)	ld HL, PlotSScreen + (x / 8) + (y * 12) \ ld BC, 256 * (w / 8) + ht \ ld A, f \ RCall( cFillBuffSect )
#define rFillBuffSectG(f, x, y, w, ht)	ld HL, SaveSScreen + (x / 8) + (y * 12) \ ld BC, 256 * (w / 8) + ht \ ld A, f \ RCall( cFillBuffSectG )
#define rFillBuffSectL(f, x, y, w, ht) ld HL, PlotSScreen + (x / 8) + (y * 12) \ ld BC, 256 * (w / 8) + ht \ ld A, f \ RCall( cFillBuffSectG )

#define rDrawRect(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ call DrawRect
#define rDrawRectD(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cDrawRectDark )
#define rDrawRectW(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cDrawRectWhite )
#define rDrawRectW2(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cDrawRectWhite2 )
#define rDrawRectW3(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cDrawRectWhite3 )
#define rDrawRectB(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cDrawRectBlack )

#define rInvRect(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cInvRect )
#define rInvRectD(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cInvRectDark )
#define rInvRectB(x, y, wid, ht)		ld HL, x * 256 + y \ ld BC, wid * 256 + ht \ RCall( cInvRectBlack )

#define rDrawBoxLbl(x, y, len)	ld HL, x * 256 + y \ #if len != XX \ ld B, len \ #endif
#defcont				\ #if len == XX \ RCall( cDrawBoxLbl ) \ #else \ RCall( cDrawBoxLbl2 ) \ #endif

; ---------------------------------------------------------------
; Archive
; ---------------------------------------------------------------

#define rGSArcSprite(x, y, pt)	ld A, x \ ld L, y \ ld IX, pt \ RCall( cArcSprite )
#define rGSArcSprite8(x, y, pt)	ld A, x \ ld L, y \ ld IX, pt \ RCall( cArcSprite8 )
#define rArcText(col, row, txt)	#if row != XX && col != XX \ ld HL, row * 256 + col \ ld (PenCol), HL
#defcont				\ #else 
#defcont				    \ #if col != XX \ ld A, col \ ld (PenCol), A \ #endif
#defcont				    \ #if row != XX \ ld A, row \ ld (PenRow), A \ #endif
#defcont				\ #endif
#defcont				\ ld HL, txt \ RCall( cArcText )
#define rArcTextN(col, row, txt, N)	#if col != XX \ ld A, col \ ld (PenCol), A \ #endif
#defcont					\ #if row != XX \ ld A, row \ ld (PenRow), A \ #endif
#defcont					\ ld HL, txt \ ld B, N \ RCall( cArcText )